/*****************************************************************************\
 *
 * unit1.cpp
 *
 * unit1 - implementation of launcher application
 *
 * Authors: Petr "Lamik" Vrba (xvrbap00 _AT stud.fit.vutbr.cz)
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TForm1::SetDefaultValues()
{
  height_map->Checked = true;
  seed_edit->Text = "0";
  seed_track->Position = 0;
  size_edit->Text = "512";
  size_track->Position = 4;
  dimension_edit->Text = "33";
  dimension_track->Position = 2;
  distance_edit->Text = "100";
  distance_track->Position = 70;
  filter_edit->Text = "0.5";
  filter_track->Position = 5;
  hq_edit->Text = "0";
  hq_track->Position = 0;
  level_edit->Text = "5";
  level_track->Position = 5;
  reduce_edit->Text = "50";
  reduce_track->Position = 50;
  x1->Text = "-1000.0";
  y1->Text = "-1000.0";
  x2->Text = "1000.0";
  y2->Text = "1000.0";
  filename->Text = "";
  SetHMap();
}

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  SetDefaultValues();
  startDir = GetCurrentDir();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::seed_trackChange(TObject *Sender)
{
  seed_edit->Text = seed_track->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::size_trackChange(TObject *Sender)
{
  switch(size_track->Position)
  {
  case 1: //64
    size_edit->Text = "64";
    break;
  case 2: //128
    size_edit->Text = "128";
    break;
  case 3: //256
    size_edit->Text = "256";
    break;
  case 4: //512
    size_edit->Text = "512";
    break;
  case 5: //1024
    size_edit->Text = "1024";
    break;
  case 6: //2048
    size_edit->Text = "2048";
    break;
  }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::dimension_trackChange(TObject *Sender)
{
  switch(dimension_track->Position)
  {
  case 1: //17
    dimension_edit->Text = "17";
    break;
  case 2: //33
    dimension_edit->Text = "33";
    break;
  case 3: //65
    dimension_edit->Text = "65";
    break;
  }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::distance_trackChange(TObject *Sender)
{
  distance_edit->Text = distance_track->Position + 30;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::filter_trackChange(TObject *Sender)
{
  if (filter_track->Position < 10)
    filter_edit->Text = "0." + AnsiString(filter_track->Position);
  else
    filter_edit->Text = "1.0";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::hq_trackChange(TObject *Sender)
{
  hq_edit->Text = hq_track->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::open_fileClick(TObject *Sender)
{
  OpenDialog1->InitialDir = GetCurrentDir();
  if (OpenDialog1->Execute())
  {
    filename->Text = OpenDialog1->FileName;
  }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::level_trackChange(TObject *Sender)
{
  level_edit->Text = level_track->Position;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::reduce_trackChange(TObject *Sender)
{
  reduce_edit->Text = reduce_track->Position;
}
//---------------------------------------------------------------------------
void TForm1::SetHMap()
{

  seed->Enabled = true;
  seed_edit->Enabled = true;
  seed_track->Enabled = true;
  size->Enabled = true;
  size_edit->Enabled = true;
  size_track->Enabled = true;
  dimension->Enabled = true;
  dimension_edit->Enabled = true;
  dimension_track->Enabled = true;
  distance->Enabled = true;
  distance_edit->Enabled = true;
  distance_track->Enabled = true;
  filter->Enabled = true;
  filter_edit->Enabled = true;
  filter_track->Enabled = true;
  hq->Enabled = true;
  hq_edit->Enabled = true;
  hq_track->Enabled = true;
  operation->Enabled = false;
  level->Enabled = false;
  level_edit->Enabled = false;
  level_track->Enabled = false;
  reduce->Enabled = false;
  reduce_edit->Enabled = false;
  reduce_track->Enabled = false;
  open_file->Enabled = false;
  coords->Enabled = false;
  x1->Enabled = false;
  y1->Enabled = false;
  x2->Enabled = false;
  y2->Enabled = false;
  filename->Enabled = false;

}

void TForm1::SetModel()
{
  seed->Enabled = false;
  seed_edit->Enabled = false;
  seed_track->Enabled = false;
  size->Enabled = false;
  size_edit->Enabled = false;
  size_track->Enabled = false;
  dimension->Enabled = false;
  dimension_edit->Enabled = false;
  dimension_track->Enabled = false;
  distance->Enabled = false;
  distance_edit->Enabled = false;
  distance_track->Enabled = false;
  filter->Enabled = false;
  filter_edit->Enabled = false;
  filter_track->Enabled = false;
  hq->Enabled = false;
  hq_edit->Enabled = false;
  hq_track->Enabled = false;
  operation->Enabled = true;
  if (operation->ItemIndex == 0)
  {
    level->Enabled = true;
    level_edit->Enabled = true;
    level_track->Enabled = true;
  }
  else
  {
    level->Enabled = false;
    level_edit->Enabled = false;
    level_track->Enabled = false;
  }
  if ((operation->ItemIndex == 0) || (operation->ItemIndex == 2))
  {
    reduce->Enabled = true;
    reduce_edit->Enabled = true;
    reduce_track->Enabled = true;
  }
  else
  {
    reduce->Enabled = false;
    reduce_edit->Enabled = false;
    reduce_track->Enabled = false;
  }
  open_file->Enabled = true;
  filename->Enabled = true;
  if ((operation->ItemIndex == 3) || (operation->ItemIndex == 4))
  {
    coords->Enabled = true;
    x1->Enabled = true;
    y1->Enabled = true;
    x2->Enabled = true;
    y2->Enabled = true;
  }
  else
  {
    coords->Enabled = false;
    x1->Enabled = false;
    y1->Enabled = false;
    x2->Enabled = false;
    y2->Enabled = false;
  }
}

void __fastcall TForm1::height_mapClick(TObject *Sender)
{
  SetHMap();  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::universal_modelClick(TObject *Sender)
{
  SetModel();  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::default_btnClick(TObject *Sender)
{
  SetDefaultValues();  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::operationChange(TObject *Sender)
{
  switch (operation->ItemIndex)
  {
  case 0:
    level->Enabled = true;
    level_edit->Enabled = true;
    level_track->Enabled = true;
    reduce->Enabled = true;
    reduce_edit->Enabled = true;
    reduce_track->Enabled = true;
    coords->Enabled = false;
    x1->Enabled = false;
    y1->Enabled = false;
    x2->Enabled = false;
    y2->Enabled = false;
    break;
  case 1:
    level->Enabled = false;
    level_edit->Enabled = false;
    level_track->Enabled = false;
    reduce->Enabled = false;
    reduce_edit->Enabled = false;
    reduce_track->Enabled = false;
    coords->Enabled = false;
    x1->Enabled = false;
    y1->Enabled = false;
    x2->Enabled = false;
    y2->Enabled = false;
    break;
  case 2:
    level->Enabled = false;
    level_edit->Enabled = false;
    level_track->Enabled = false;
    reduce->Enabled = true;
    reduce_edit->Enabled = true;
    reduce_track->Enabled = true;
    coords->Enabled = false;
    x1->Enabled = false;
    y1->Enabled = false;
    x2->Enabled = false;
    y2->Enabled = false;
    break;
  case 3:
    level->Enabled = false;
    level_edit->Enabled = false;
    level_track->Enabled = false;
    reduce->Enabled = false;
    reduce_edit->Enabled = false;
    reduce_track->Enabled = false;
    coords->Enabled = true;
    x1->Enabled = true;
    y1->Enabled = true;
    x2->Enabled = true;
    y2->Enabled = true;
    break;
  case 4:
    level->Enabled = false;
    level_edit->Enabled = false;
    level_track->Enabled = false;
    reduce->Enabled = false;
    reduce_edit->Enabled = false;
    reduce_track->Enabled = false;
    coords->Enabled = true;
    x1->Enabled = true;
    y1->Enabled = true;
    x2->Enabled = true;
    y2->Enabled = true;
    break;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::run_btnClick(TObject *Sender)
{
  AnsiString params = "";
  if (height_map->Checked)
  {
    params += " -seed ";
    params += seed_edit->Text;
    params += " -size ";
    params += size_edit->Text;
    params += " -dimension ";
    params += dimension_edit->Text;
    params += " -distance ";
    params += distance_edit->Text;
    params += " -filterQ ";
    params += filter_edit->Text;
    params += " -hq ";
    params += hq_edit->Text;
    AnsiString tmp;
    tmp = startDir;
    tmp += "\\perlin.exe";
    ShellExecute(this->WindowHandle,"open",tmp.c_str(),params.c_str(),GetCurrentDir().c_str(),SW_SHOW);
  }
  else
  {
    if (filename->Text != "")
    {
      switch (operation->ItemIndex)
      {
      case 0:
        params += " \"" + filename->Text + "\"";
        params += " -operation ";
        params += operation->ItemIndex;
        params += " -level ";
        params += level_edit->Text;
        params += " -reduce ";
        params += reduce_edit->Text;
       break;
      case 1:
        params += " \"" + filename->Text + "\"";
        params += " -operation ";
        params += operation->ItemIndex;
       break;
      case 2:
        params += " \"" + filename->Text + "\"";
        params += " -operation ";
        params += operation->ItemIndex;
        params += " -reduce ";
        params += reduce_edit->Text;
       break;
      case 3:
        params += " \"" + filename->Text + "\"";
        params += " -operation ";
        params += operation->ItemIndex;
        params += " -x1 ";
        params += x1->Text;
        params += " -y1 ";
        params += y1->Text;
        params += " -x2 ";
        params += x2->Text;
        params += " -y2 ";
        params += y2->Text;
       break;
      }
      AnsiString tmp;
      tmp = startDir;
      tmp += "\\chunkedLOD.exe";
      ShellExecute(this->WindowHandle,"open",tmp.c_str(),params.c_str(),GetCurrentDir().c_str(),SW_SHOW);
    }
    else
    {
      MessageBox(this->WindowHandle, "Model filename is NOT set.","Error",MB_ICONERROR);
    }
  }
}
//---------------------------------------------------------------------------


